import util.*;
import gui.*;
import map.*;
import java.applet.Applet;
import java.awt.*;
import java.io.*;
import com.sun.j3d.utils.applet.MainFrame;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.picking.PickTool;
import com.sun.j3d.utils.picking.behaviors.*;
import com.sun.j3d.utils.geometry.*;
import com.sun.j3d.utils.applet.MainFrame;
import javax.media.j3d.*;
import javax.vecmath.*;
import javax.swing.JFrame;
import java.util.*;

public class SceneGenerator {

	private Building building;
	private String fileName;
	private static double NOVAL = -99999.99999;
	private double minLong = NOVAL;
	private double minLat = NOVAL;
	private double maxLong = NOVAL;
	private double maxLat = NOVAL;
	private double scalingFactor;
    private SimpleUniverse u = null;
    private GraphicsConfiguration config;
    private Canvas3D c;
    private BranchGroup scene;
    public boolean isDone = false;

	public SceneGenerator(String fname){
		fileName = fname;
		config = SimpleUniverse.getPreferredConfiguration();
		c = new Canvas3D(config);
		//u = new SimpleUniverse(c);
		scene = createSceneGraph(c);

		// This will move the ViewPlatform back a bit so the
		// objects in the scene can be viewed.
		//u.getViewingPlatform().setNominalViewingTransform();

		//u.addBranchGraph(scene);
		System.out.println("finished rendering scene");
		isDone = true;

	}

	public SceneGenerator(Building b){}


	public Canvas3D getCanvas3D(){
		return c;
	}

	public void loadBuilding(String fname){
		try{
			FileInputStream fin = new FileInputStream(fname);
			ObjectInputStream oin = new ObjectInputStream(fin);
			building = (Building)oin.readObject();
		} catch(Exception e){
			System.out.println("Error Loading Map File:" + e);
			building = new Building("Empty");
		}
	}

	//public static void main(String[] args){
	//	SceneGenerator sg = new SceneGenerator("jason.map");
	//	sg.printInfo();
	//}
	public static void main(String[] args) {
	    System.out.println("Creating Scene Renderer");
	    System.out.println("waiting for scene to render");
	    SceneGenerator sg = new SceneGenerator("jason.map");
	    //while(!(sg.isDone)){}
	    System.out.println("Initializing Viewer");
	    //Viewer viewer = new Viewer(sg.getCanvas3D());
	    Viewer viewer = new Viewer(sg.getCanvas3D());


    	try{
			viewer.setVisible(true);
			System.out.println("Viewer Initialized");
		} catch(Exception e){System.out.println("Error Initializing Viewer");}

	    //System.out.println("Viewer Initialized");
	    //viewer.setVisible(true);
	    //JFrame[] jf = viewer.getJFrames();
	    //System.out.println(jf.length);
  	}

	public void printInfo(){
		findScale();
		System.out.println("Map Size:");
		System.out.println("("+minLong+","+minLat+") --> ("+maxLong+","+maxLat+")");
		Vector floors = building.getFloors();
		for(int f=0;f<floors.size();f++){
			System.out.println("Floor #" + (f+1));
			Vector rooms = ((Floor)floors.get(f)).getRooms();
			for(int r=0;r<rooms.size();r++){
				System.out.println(" - Room #" + (r+1));
				Vector walls = ((Room)rooms.get(r)).getWalls();
				for(int w=0;w<walls.size();w++){
					System.out.println("   + Wall #" + (w+1));
					System.out.println("     (" + convertLong(((Wall)walls.get(w)).getPosition1().getPureLng())+","+convertLat(((Wall)walls.get(w)).getPosition1().getPureLat()) + ") --> (" + convertLong(((Wall)walls.get(w)).getPosition2().getPureLng())+","+convertLat(((Wall)walls.get(w)).getPosition2().getPureLat())+")");
				}
			}
		}
	}

	public BranchGroup createSceneGraph(Canvas3D canvas) {
		Color3f eColor    = new Color3f(0.0f, 0.0f, 0.0f);
	    Color3f sColor    = new Color3f(1.0f, 1.0f, 1.0f);
	    Color3f objColor  = new Color3f(0.6f, 0.6f, 0.6f);
	    Color3f lColor1   = new Color3f(1.0f, 0.0f, 0.0f);
	    Color3f lColor2   = new Color3f(0.0f, 1.0f, 0.0f);
	    Color3f alColor   = new Color3f(0.2f, 0.2f, 0.2f);
	    Color3f bgColor   = new Color3f(0.05f, 0.05f, 0.2f);

	    Transform3D t;

	    // Create the root of the branch graph
	    BranchGroup objRoot = new BranchGroup();

	    //TransformGroup objRot = new TransformGroup();
	    //Transform3D t3dr = new Transform3D();
	    //t3dr.setRotation(new AxisAngle4d(0.0d,0.0d,0.0d,-30.2));
	    //objRot.setTransform(t3dr);
	    //objRoot.addChild(objRot);

	    // Create a Transformgroup to scale all objects so they
	    // appear in the scene.
	    TransformGroup objScale = new TransformGroup();
	    Transform3D t3d = new Transform3D();
	    t3d.setScale(0.4);
	    objScale.setTransform(t3d);
	    objRoot.addChild(objScale);

	    // Create a bounds for the background and lights
	    BoundingSphere bounds =
	      new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);

	    // Set up the background
	    Background bg = new Background(bgColor);
	    bg.setApplicationBounds(bounds);
	    objScale.addChild(bg);

	    Material m = new Material(objColor, eColor, objColor, sColor, 100.0f);
	    Appearance a = new Appearance();
	    m.setLightingEnable(true);
	    a.setMaterial(m);
	    //Font3D f3d = new Font3D(new Font("TestFont", Font.PLAIN, 1),
		//		    new FontExtrusion());
	//
	    //Text3D text3D = new Text3D(f3d, new String("TEXT3D"),
		//		    new Point3f(-2.0f, 0.7f, 0.0f));
	    //text3D.setCapability(Geometry.ALLOW_INTERSECT);
	    //Shape3D s3D1 = new Shape3D();
	    //s3D1.setGeometry(text3D);
	    //s3D1.setAppearance(a);
	 	//
	 	//// Create a transform group node and initialize it to the
	    //// identity.  Enable the TRANSFORM_WRITE capability so that
	    //// our behavior code can modify it at runtime.
	    //TransformGroup spinTg1 = new TransformGroup();
	    //spinTg1.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	    //spinTg1.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	    //spinTg1.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	//
	    //spinTg1.addChild(s3D1);
	    //objScale.addChild(spinTg1);
	//
	    //Text3D pick = new Text3D(f3d, new String("Pick me"),
		//		    new Point3f(-2.0f, -0.7f, 0.0f));
	    //pick.setCapability(Geometry.ALLOW_INTERSECT);
	    //Shape3D s3D2 = new Shape3D();
	    //s3D2.setGeometry(pick);
	    //s3D2.setAppearance(a);
	//
	    // Create a transform group node and initialize it to the
	    // identity.  Enable the TRANSFORM_WRITE capability so that
	    // our behavior code can modify it at runtime.
	    //TransformGroup spinTg2 = new TransformGroup();
	    //spinTg2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
	    //spinTg2.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
	    //spinTg2.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
	//
	    //spinTg2.addChild(s3D2);
	    //objScale.addChild(spinTg2);

	    // Create the transform group node for the each light and initialize
	    // it to the identity.  Enable the TRANSFORM_WRITE capability so that
	    // our behavior code can modify it at runtime.  Add them to the root
	    // of the subgraph.

	    // Create lights
	    //AmbientLight aLgt = new AmbientLight(alColor);
//
	    //Light lgt1;
	    //Light lgt2;
//
	    //Point3f lPoint  = new Point3f(0.0f, 0.0f, 0.0f);
	    //Point3f atten = new Point3f(1.0f, 0.0f, 0.0f);
	    //lgt1 = new PointLight(lColor1, lPoint, atten);
	    //lgt2 = new PointLight(lColor2, lPoint, atten);
//
	    //// Set the influencing bounds
	    //aLgt.setInfluencingBounds(bounds);
	    //lgt1.setInfluencingBounds(bounds);
	    //lgt2.setInfluencingBounds(bounds);
//
	    //// Add the lights into the scene graph
	    //objScale.addChild(aLgt);
	    //l1Trans.addChild(lgt1);
	    //l2Trans.addChild(lgt2);
//
	    //PickRotateBehavior behavior1 =
		//new PickRotateBehavior(objRoot, canvas, bounds);
	    //behavior1.setMode(PickTool.GEOMETRY);
	    //behavior1.setTolerance(0.0f);
	    //objRoot.addChild(behavior1);
//
	    //PickZoomBehavior behavior2 =
		//new PickZoomBehavior(objRoot, canvas, bounds);
	    //behavior2.setMode(PickTool.GEOMETRY);
	    //behavior2.setTolerance(0.0f);
	    //objRoot.addChild(behavior2);
//
	    //PickTranslateBehavior behavior3 =
		//new PickTranslateBehavior(objRoot, canvas, bounds);
	    //behavior3.setMode(PickTool.GEOMETRY);
	    //behavior3.setTolerance(0.0f);
	    //objRoot.addChild(behavior3);

	    // Let Java 3D perform optimizations on this scene graph.

		//MY CODE STARTS HERE
		System.out.println("Finding Scaling Factor");
		loadBuilding(fileName);
		findScale();
		System.out.println("Scaling Factor: " + scalingFactor);
		System.out.println("Creating Walls");
		Vector floors = building.getFloors();
		for(int f=0;f<floors.size();f++){
			Vector rooms = ((Floor)floors.get(f)).getRooms();
			for(int r=0;r<rooms.size();r++){
				Vector walls = ((Room)rooms.get(r)).getWalls();
				for(int w=0;w<walls.size();w++){
					double x1 = convertLong(((Wall)walls.get(w)).getPosition1().getPureLng());
					double y1 = convertLat(((Wall)walls.get(w)).getPosition1().getPureLat());
					double z1 = 0.0d;
					double x2 = convertLong(((Wall)walls.get(w)).getPosition2().getPureLng());
					double y2 = convertLat(((Wall)walls.get(w)).getPosition2().getPureLat());
					double z2 = 0.4d; // chenge this to calculate height
					float width = (float)Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1));
					float height = (float)(z2-z1);
					float depth = (float)0.01d; // change this to wall thickness
					// Now add the wall to the scene
					t = new Transform3D();
					Vector3d wallPos =  new Vector3d(x1, y1, z1);
					t.set(wallPos);
					t.setRotation(new AxisAngle4d(0.0d,1.0d,0.0d,Math.atan((y2-y1)/(x2-x1))));
					TransformGroup l1Trans = new TransformGroup(t);
					l1Trans.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
					l1Trans.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
					l1Trans.setCapability(TransformGroup.ENABLE_PICK_REPORTING);
					objScale.addChild(l1Trans);

					// Rotate the walls in to the proper orientation
					//TransformGroup wallRot = new TransformGroup();
					//Transform3D t3dr = new Transform3D();
					//t3dr.setRotation(new AxisAngle4d(0.0d,0.0d,0.0d,-30.2));
					//objRot.setTransform(t3dr);
	    			//objScale.addChild(objRot);

					// Create Geometry for point lights
					ColoringAttributes caL1 = new ColoringAttributes();
					caL1.setColor(lColor1);
					Appearance appL1 = new Appearance();
					appL1.setColoringAttributes(caL1);
					l1Trans.addChild(new Box(width,height,depth,appL1));
					System.out.println("Created Wall");

				}
			}
		}
		objRoot.compile();

	    return objRoot;
	}

	public double convertLat(double lat){
		double l = lat - minLat;
		return (scalingFactor * l) - 1.00000d;
	}

	public double convertLong(double lng){
		double l = lng - minLong;
		return (scalingFactor * l) - 1.00000d;
	}

	public void findScale(){
		Vector floors = building.getFloors();
		for(int f=0;f<floors.size();f++){
			Vector rooms = ((Floor)floors.get(f)).getRooms();
			for(int r=0;r<rooms.size();r++){
				Vector walls = ((Room)rooms.get(r)).getWalls();
				for(int w=0;w<walls.size();w++){
					double long1 = ((Wall)walls.get(w)).getPosition1().getPureLng();
					double lat1  = ((Wall)walls.get(w)).getPosition1().getPureLat();
					double long2 = ((Wall)walls.get(w)).getPosition2().getPureLng();
					double lat2  = ((Wall)walls.get(w)).getPosition2().getPureLat();
					if(minLong == NOVAL)
						minLong = long1;
					if(maxLong == NOVAL)
						maxLong = long1;
					if(minLat == NOVAL)
						minLat = lat1;
					if(maxLat == NOVAL)
						maxLat = lat1;
					if(long1>maxLong)
						maxLong = long1;
					if(long1<minLong)
						minLong = long1;
					if(long2>maxLong)
						maxLong = long2;
					if(long2<minLong)
						minLong = long2;
					if(lat1>maxLat)
						maxLat = lat1;
					if(lat1<minLat)
						minLat = lat1;
					if(lat2>maxLat)
						maxLat = lat2;
					if(lat2<minLat)
						minLat = lat2;
				}
			}
		}
		double lngSize = maxLong - minLong;
		double latSize = maxLat - minLat;
		double fctrSize;
		if(lngSize>latSize)
			fctrSize = lngSize;
		else
			fctrSize = latSize;
		scalingFactor = (2.0d)/fctrSize;
	}

}